about summary refs log tree commit diff
path: root/tests/secure-drv-outputs.sh
diff options
context:
space:
mode:
authorEelco Dolstra <e.dolstra@tudelft.nl>2011-07-20T12·15+0000
committerEelco Dolstra <e.dolstra@tudelft.nl>2011-07-20T12·15+0000
commitd2bfe1b071d0d71bb981535a53e9c5de43aaac81 (patch)
treeebf46ffb027950c453f25588204b98b7bbc58c2b /tests/secure-drv-outputs.sh
parent4bdb51e621e2690e561b7581d5670af08e7b3170 (diff)
* Added a test that make sure that users cannot register
  specially-crafted derivations that produce output paths belonging to
  other derivations.  This could be used to inject malware into the
  store.

Diffstat (limited to 'tests/secure-drv-outputs.sh')
-rw-r--r--tests/secure-drv-outputs.sh37
1 files changed, 37 insertions, 0 deletions
diff --git a/tests/secure-drv-outputs.sh b/tests/secure-drv-outputs.sh
new file mode 100644
index 0000000000..25dd6bfc01
--- /dev/null
+++ b/tests/secure-drv-outputs.sh
@@ -0,0 +1,37 @@
+# Test that users cannot register specially-crafted derivations that
+# produce output paths belonging to other derivations.  This could be
+# used to inject malware into the store.
+
+source common.sh
+
+clearStore
+clearManifests
+
+startDaemon
+
+# Determine the output path of the "good" derivation.
+goodOut=$($nixstore -q $($nixinstantiate ./secure-drv-outputs.nix -A good))
+
+# Instantiate the "bad" derivation.
+badDrv=$($nixinstantiate ./secure-drv-outputs.nix -A bad)
+badOut=$($nixstore -q $badDrv)
+
+# Rewrite the bad derivation to produce the output path of the good
+# derivation.
+rm -f $TEST_ROOT/bad.drv
+sed -e "s|$badOut|$goodOut|g" < $badDrv > $TEST_ROOT/bad.drv
+
+# Add the manipulated derivation to the store and build it.  This
+# should fail.
+if badDrv2=$($nixstore --add $TEST_ROOT/bad.drv); then
+    $nixstore -r "$badDrv2"
+fi
+
+# Now build the good derivation.
+goodOut2=$($nixbuild ./secure-drv-outputs.nix -A good)
+test "$goodOut" = "$goodOut2"
+
+if ! test -e "$goodOut"/good; then
+    echo "Bad derivation stole the output path of the good derivation!"
+    exit 1
+fi